! converts a compressed matrix into a standard array matrix 
subroutine csm2mat(csm,a)
  use csm_mod
  use misc_interface
  implicit none
  type(csmat),intent(in) :: csm
  real(kind(0.d0)),allocatable,dimension(:,:),intent(out) :: a
  integer :: n,i,j

  call d_mat_alloc(a,csm%n)
  a=0
  do j=1,csm%n
     do i=csm%colptr(j),csm%colptr(j+1)-1
        a(csm%rowind(i),j)=csm%values(i)
     enddo
  enddo
endsubroutine csm2mat
