! reads the ith command-line parameter stored in a text file
function get_param(filename,n) result(p)
  implicit none
  character(len=80) :: p ! fixed-size is needed for inclusion in an interface
  character(len=*),intent(in) :: filename
  integer,intent(in) :: n
  integer :: fileunit,ios,as,i
  interface
     function get_fileunit() result(fileunit)
       integer :: fileunit
     endfunction get_fileunit
     subroutine error(code) 
       integer,intent(in) :: code
     endsubroutine error
  endinterface

  fileunit=get_fileunit()
  open(unit=fileunit,file=filename,status='old',iostat=ios)
  if(ios/=0) call error(201)
  do i=1,n-1
     read(unit=fileunit,fmt='(a)',iostat=ios)
  enddo
  read (unit=fileunit,fmt='(a)',iostat=ios) p
  close(unit=fileunit)
  return
endfunction get_param
