! allocates a 1 dim array for n integers
subroutine i_vect_alloc(v,n)
  implicit none
  integer,allocatable,dimension(:),intent(out) :: v
  integer,intent(in) :: n
  integer :: as
  interface
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
  endinterface

  if(allocated(v)) deallocate(v)
  if(.not.allocated(v)) then
     allocate(v(n),stat=as)
     if(as/=0) call error(204)
  endif
endsubroutine i_vect_alloc
