! ads a line to the log file
subroutine log_add(logline,filename_param)
  implicit none
  character(len=*),optional,intent(in) :: logline
  character(len=*),optional,intent(in) :: filename_param
  character(len=80),save :: filename ! can't use (len=*) with the save option
  integer :: fileunit,ios
  interface
     function get_fileunit() result(fileunit)
       integer :: fileunit
     endfunction get_fileunit
  endinterface

  if(present(filename_param)) then
     filename=filename_param
  else
     fileunit=get_fileunit()
     do 
        open(unit=fileunit,file=trim(filename),status='old',iostat=ios)
        if(ios==0) exit ! repeats for we can access the log during execution     
     enddo
     do
        read(unit=fileunit,fmt='(a)',iostat=ios)
        if(ios/=0) exit
     enddo
     write(unit=fileunit,fmt='(a)') logline
     close(unit=fileunit)
  endif
  return
endsubroutine log_add
