! ads a typical line to the log file
subroutine log_line(time,eps)
  implicit none
  real,intent(in) :: time
  real(kind(0.d0)),intent(in) :: eps
  interface
     subroutine log_add(logline,filename_param)
       implicit none
       character(len=*),optional,intent(in) :: logline
       character(len=*),optional,intent(in) :: filename_param
     endsubroutine log_add
     function real2char(r) result(c)
       real,intent(in) :: r
       character(len=40) :: c
     endfunction real2char
     function double2char(d) result(c)
       real(kind(0.d0)),intent(in) :: d
       character(len=60) :: c
     endfunction double2char
  endinterface

  call log_add(trim(adjustl(real2char(time)))//&
       ' '//trim(adjustl(double2char(eps))))
  return
endsubroutine log_line
