! product csm*x
subroutine csm_vect_pdt(csm,x,y)
  use csm_mod
  use misc_interface
  implicit none
  type(csmat),intent(in) :: csm
  real(kind(0.d0)),dimension(:),intent(in) :: x
  real(kind(0.d0)),dimension(:),intent(out) :: y
  integer :: i,j

  if((size(x)/=csm%n).or.(size(y)/=csm%n)) call error(401)
  y=0
  do j=1,csm%n
     do i=csm%colptr(j),csm%colptr(j+1)-1
        y(csm%rowind(i))=y(csm%rowind(i))+csm%values(i)*x(j)
     enddo
  enddo
return
endsubroutine csm_vect_pdt
