! product x*csm
subroutine vect_csm_pdt(x,csm,y)
  use csm_mod
  use misc_interface
  implicit none
  real(kind(0.d0)),dimension(:),intent(in) :: x
  type(csmat),intent(in) :: csm
  real(kind(0.d0)),dimension(:),intent(out) :: y
  integer :: i,j

  if((size(x)/=csm%n).or.(size(y)/=csm%n)) call error(410)
  y=0 
  do j=1,csm%n
     do i=csm%colptr(j),csm%colptr(j+1)-1
        y(j)=y(j)+x(csm%rowind(i))*csm%values(i)
     enddo
  enddo
return
endsubroutine vect_csm_pdt
