! allocates a 2 dim array for n1*n2 double
subroutine d_mat_alloc(a,n1,n2)
  implicit none
  real(kind(0.d0)),allocatable,dimension(:,:),intent(out) :: a
  integer,intent(in) :: n1
  integer,optional,intent(in) :: n2
  integer :: as
  interface
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
  endinterface

  if(allocated(a)) deallocate(a)
  if(.not.allocated(a)) then
     if(.not.present(n2)) then
        allocate(a(n1,n1),stat=as)
     else
        allocate(a(n1,n2),stat=as)
     endif
     if(as/=0) call error(204)
  endif
endsubroutine d_mat_alloc
