! allocates a 1 dim array for n double values
subroutine d_vect_alloc(v,n)
  implicit none
  real(kind(0.d0)),allocatable,dimension(:),intent(out) :: v
  integer,intent(in) :: n
  integer :: as
  interface
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
  endinterface

  if(allocated(v)) deallocate(v)
  if(.not.allocated(v)) then
     allocate(v(n),stat=as)
     if(as/=0) call error(204)
  endif
endsubroutine d_vect_alloc
