! gets the number of command-line parameters stored in a text file
function get_params_nb(filename) result(n)
  implicit none
  character(len=*),intent(in) :: filename
  integer :: n
  integer :: fileunit,ios
  interface
     function get_fileunit() result(fileunit)
       integer :: fileunit
     endfunction get_fileunit
     subroutine error(code) 
       integer,intent(in) :: code
     endsubroutine error
  endinterface

  fileunit=get_fileunit()
  open(unit=fileunit,file=filename,status='old',iostat=ios)
  if(ios/=0) call error(201)
  n=0
  do
     read(unit=fileunit,fmt='(a)',iostat=ios)
     if(ios/=0) exit
     n=n+1
  enddo
  close(unit=fileunit)
  return
endfunction get_params_nb
