! log management init
subroutine log_init(filename)
  implicit none
  character(len=*),intent(in) :: filename
  integer :: fileunit,ios
  interface
     function get_fileunit() result(fileunit)
       integer :: fileunit
     endfunction get_fileunit
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
     subroutine log_add(logline,filename_param)
       character(len=*),optional,intent(in) :: logline
       character(len=*),optional,intent(in) :: filename_param
     endsubroutine log_add
  endinterface

  fileunit=get_fileunit()
  open(unit=fileunit,file=filename,status='replace',iostat=ios)
  if(ios/=0) call error(201)
  close(unit=fileunit)
  call log_add('',filename)
endsubroutine log_init
